module Test.Main where

import Control.Arrow ((***))

import Test.HUnit
import Zipper
import qualified Test.BTree as ZB
import qualified Test.Tree  as ZT

-- Utility functions
--

mkTests :: (Show a, Show b, Eq b) => 
           [(a, b)] -> (a -> b) -> String -> [Test]
mkTests tvs f fname = map test' tvs where
    -- test' :: (a, b) -> Test with mkTests' constraints
    test' (x, y) = (name x) ~: f x ~?= y
    name x       = fname ++ " " ++ show x

mkTests3 :: (Show a, Show b, Show c, Eq c) => 
            [(a, b, c)] -> (a -> b -> c) -> String -> [Test]
mkTests3 tvs f fname = map test' tvs where
    -- test' :: (a, b) -> Test with mkTests' constraints
    test' (x, y, z) = (name x y) ~: f x y ~?= z
    name x y        = fname ++ " " ++ show x ++ " " ++ show y

-- Put the tests together
--

allTests = [ ("ZipperBTree", ZB.tests),
             ("ZipperTree",  ZT.tests) ]

main = mapM (uncurry (>>) . (putStrLn *** runTestTT)) allTests